#pragma once
#include "afxwin.h"

#include <string>

#include "HelloStoveDlg.h"


//CString char* to wchar_t*
CString MtoW(char* data)
{
    int length;
    CString retString;
    BSTR buffer;

    // 1. char* to wchar * conversion
    length = MultiByteToWideChar(CP_ACP, 0, data, strlen(data), NULL, NULL);
    buffer = SysAllocStringLen(NULL, length);
    MultiByteToWideChar(CP_ACP, 0, data, strlen(data), buffer, length);

    // 2. wchar_t* to CString conversion
    retString.Format(_T("%s"), buffer);

    SysFreeString(buffer);
    return retString;
}

char* WtoM(CString data)
{
    // Unicode CString -> char* ȯ  
    // CString -> wchar* -> char*  ȯ Ǿ 

    wchar_t* wcharStr;
    char* charStr;
    int charStrLen;

    // 1. CString to wchar * conversion
    wcharStr = data.GetBuffer(data.GetLength());
    charStrLen = WideCharToMultiByte(CP_ACP, 0, wcharStr, -1, NULL, 0, NULL, NULL);
    charStr = new char[charStrLen];

    // 2. wchar_t* to char* conversion
    WideCharToMultiByte(CP_ACP, 0, wcharStr, -1, charStr, charStrLen, 0, 0);

    return charStr;
}

CString getSDKCurrentPath()
{
    TCHAR path[_MAX_PATH];
    GetModuleFileName(NULL, path, sizeof(path));

    CString strPath = path;
    int i = strPath.ReverseFind('\\');      //  ̸  ؼ ʿ ִ '/' ã´.
    strPath = strPath.Left(i);                    // ڿ ִ   ̸ .
    return strPath;
}




