// CHelloStoveDlg.cpp :  
//

#include "stdafx.h"
#include "afxdialogex.h"



#include <sstream>
#include <iostream>
#include <chrono>
#include <thread>

#include "HelloStove.h"
#include "HelloStoveDlg.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

void OnLog(CString log)
{
    CHelloStoveDlg* helloStoveDlg = (CHelloStoveDlg*)(AfxGetApp()->GetMainWnd());
    helloStoveDlg->Log(log);
}

//Sample Callback
//void OnError(const StovePCError error)
//{
//    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
//}
//
//void OnInitComplete()
//{
//    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
//}
//
//void OnToken(const StovePCToken token)
//{
//    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
//}
//
//void OnUser(const StovePCUser user)
//{
//    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
//}

// CStovePCSDKTestMfcDlg ȭ 
CHelloStoveDlg::CHelloStoveDlg(CWnd* pParent /*=NULL*/)
    : CDialogEx(IDD_STOVEPCSDKTESTMFC_DIALOG, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHelloStoveDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LOG, _logEdit);
    DDX_Control(pDX, IDC_INIT, _initButton);
    DDX_Control(pDX, IDC_UNINIT, _unInitButton);
    DDX_Control(pDX, IDC_GETTOKEN, _getTokenButton);
    DDX_Control(pDX, IDC_USERINFO, _getUserButton);
}

BEGIN_MESSAGE_MAP(CHelloStoveDlg, CDialogEx)
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_WM_TIMER()
    ON_BN_CLICKED(IDC_INIT, &CHelloStoveDlg::OnBnClickedInit)
    ON_BN_CLICKED(IDC_GETTOKEN, &CHelloStoveDlg::OnBnClickedGetToken)
    ON_BN_CLICKED(IDC_USERINFO, &CHelloStoveDlg::OnBnClickedGetUser)
    ON_BN_CLICKED(IDC_UNINIT, &CHelloStoveDlg::OnBnClickedUnInit)
END_MESSAGE_MAP()

void CHelloStoveDlg::Log(const CString& message)
{
    _logEdit.InsertLines(message, FALSE);
}

// CStovePCSDKTestMfcDlg ޽ ó

BOOL CHelloStoveDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    //  ȭ   մϴ.   α׷  â ȭ ڰ ƴ 쿡
    //  ӿũ  ۾ ڵ մϴ.
    SetIcon(m_hIcon, TRUE);      // ū  մϴ.
    SetIcon(m_hIcon, FALSE);    //   մϴ.

    return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ.  /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CHelloStoveDlg::OnPaint()
{
    if (IsIconic())
    {
        CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

        SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
        // Ŭ̾Ʈ 簢   ϴ.
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  ׸ϴ.
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialogEx::OnPaint();
    }
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CHelloStoveDlg::OnQueryDragIcon()
{
    return static_cast<HCURSOR>(m_hIcon);
}

void CHelloStoveDlg::OnTimer(UINT_PTR nIDEvent)
{
    if (nIDEvent == USER_TIMER)
    {
        /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
    }
    CDialogEx::OnTimer(nIDEvent);
}

void CHelloStoveDlg::_displayConfig(const StovePCConfig& config)
{
    //config log
    /*OnLog(L"<config>");

    CString log;
    log.Format(L"env : %s", MtoW(config.env));
    OnLog(log);

    log.Format(L"appKey : %s", MtoW(config.appKey));
    OnLog(log);

    log.Format(L"secretKey : %s", MtoW(config.secretKey));
    OnLog(log);

    log.Format(L"gameId : %s", config.gameId);
    OnLog(log);

    log.Format(L"logLevel : %d", config.logLevel);
    OnLog(log);

    log.Format(L"logPath : %s", config.logPath);
    OnLog(log);*/
}

BOOL CHelloStoveDlg::DestroyWindow()
{
    // TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
    KillTimer(USER_TIMER);
    return CDialogEx::DestroyWindow();
}

void CHelloStoveDlg::OnBnClickedInit()
{
    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
}

void CHelloStoveDlg::OnBnClickedUnInit()
{
    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
}

void CHelloStoveDlg::OnBnClickedGetToken()
{
    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
}

void CHelloStoveDlg::OnBnClickedGetUser()
{
    /*⿡ 'ϱ' ڵ带 ߰մϴ.*/
}
