// LogEdit.cpp :  Դϴ.
//

#include "stdafx.h"
#include "HelloStove.h"
#include "LogEdit.h"


// CLogEdit

IMPLEMENT_DYNAMIC(CLogEdit, CEdit)

CLogEdit::CLogEdit()
    : flag(1)
    , PromptStr("")
{
   
}

CLogEdit::~CLogEdit()
{
}


BEGIN_MESSAGE_MAP(CLogEdit, CEdit)
    ON_WM_SETFOCUS()
    ON_WM_CHAR()
    ON_WM_LBUTTONDBLCLK()
    ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()



// CLogEdit ޽ óԴϴ.

void CLogEdit::InsertLines(CString line, BOOL st)
{
    CString wndtext;
    GetWindowText(wndtext);
    int text_length = wndtext.GetLength();
    if (text_length <= 1)
    {
        if (!st)
        {
            wndtext = wndtext + line;
        }
        else
        {
            wndtext = wndtext + PromptStr + line;
        }
        
    }
    else
    {
        if (!st)
        {
            wndtext = wndtext + "\r\n" + line;
        }
        else
        {
            wndtext = wndtext + "\r\n" + PromptStr + line;
        }
        
    }

    SetWindowText(wndtext);
    LineScroll(GetLineCount(), 0x0);
}

void CLogEdit::UpdateCaretPos()
{
    for (int i = 0; i < GetLineCount(); i++)
    {
        SendMessage(WM_KEYDOWN, VK_DOWN, 0x0);
    }
    for (int i = 0; i < LineLength(-1); i++)
    {
        SendMessage(WM_KEYDOWN, VK_RIGHT, 0x0);
    }
    
}

void CLogEdit::OnSetFocus(CWnd* pOldWnd)
{
    CEdit::OnSetFocus(pOldWnd);

    if (flag == 1)
    {
        //SetFont(&F);
        flag = 0;
        InsertLines(L"StovePCSDKTest Demo Version 1.0 ", FALSE);
        InsertLines(L"------------------------------------------ ", FALSE);
    }

    UpdateCaretPos();
}

void CLogEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    UpdateCaretPos();
    return;
}

void CLogEdit::OnLButtonDblClk(UINT nFlags, CPoint point)
{
    UpdateCaretPos();
}

void CLogEdit::OnLButtonDown(UINT nFlags, CPoint point)
{
    UpdateCaretPos();
}




